/* Phase 3 lex file
   Nick Toothman
   CS 450

   no major changes: removed some unnecessary tokens, that's about it

*/

%{

#include <stdlib.h>
#include <string.h>
#include "y.tab.h"
#include "globals.h"
#include "symtab.h"

char tokenString[MAXTOKENLEN+1];
int line_no = 1;
int col_no = 1;
int c;
%}

/* define yytext to be an array rather than a pointer */
%array

digit       [0-9]
integer     {digit}+
float       {digit}+|{digit}+\.{digit}*
letter      [a-zA-Z]
identifier  ({letter}|_)+({digit}|{letter})*
charLiteral \'({letter}|{digit})\'
newline     \n
whitespace  [ \t]+
comment     (\/\/|\/\*)+.*(\*\/)*

%%

"if"            { return IF;}
"then"          { return THEN;}
"else"          { return ELSE;}
"end"           { return END;}
"until"         { return UNTIL;}
"read"          { return READ;}
"write"         { return WRITE;}
"return"        { return RETURN; }
"class"         { return CLASS; }

"="             { return ASSIGN;}
"+"             { return PLUS;}
"-"             { return MINUS;}
"*"             { return TIMES;}
"/"             { return OVER;}

"("             { return LPAREN; }
"{"             { return LBRACE; }

{charLiteral}   { return CHARLIT; }

")"             {
                  return RPAREN;
                }
"}"             { return RBRACE; }
";"             { return SEMI; }
","		{ return COMMA; }
{integer}       {
                  strncpy(tokenString,yytext,yyleng);
                  tokenString[yyleng] = '\0';
                  return INT; 
                }
{float}         { 
                  strncpy(tokenString,yytext,yyleng);
                  tokenString[yyleng] = '\0';
                  return REAL;
                }

{identifier}    { 
                  strncpy(tokenString,yytext,yyleng);
                  tokenString[yyleng] = '\0';
                  return ID;
                }

{newline}       { line_no++; col_no = 1; }

{whitespace}    { col_no++; /* count columns then skip whitespace */}

{comment}       { line_no++; }
.               { return ERROR;}

%%
