/* token.h: 
 * Contains struct type used to keep track of important tokens
 * during lexical analysis and parsing
 */

#ifndef _TOKEN_H_
#define _TOKEN_H_

#include "globals.h"

typedef struct Token
{
  // token name
  char*  name;

  // token type
  char   type; 
  /* L literal
   * I identifier
   * C constant identifier
   * O operator
   * F function
   */

  // token data type
  char   data; 
  /*
   * V void
   * R real
   * I integer
   * C char
   * S string
   */


  /* function values */

  // return value
  char*  rValue;

  // number of params
  int params;
} Token;

#endif

